#!/usr/bin/env python




##################################################
## DEPENDENCIES
import sys
import os
import os.path
from os.path import getmtime, exists
import time
import types
import __builtin__
from Cheetah.Version import MinCompatibleVersion as RequiredCheetahVersion
from Cheetah.Version import MinCompatibleVersionTuple as RequiredCheetahVersionTuple
from Cheetah.Template import Template
from Cheetah.DummyTransaction import DummyTransaction
from Cheetah.NameMapper import NotFound, valueForName, valueFromSearchList, valueFromFrameOrSearchList
from Cheetah.CacheRegion import CacheRegion
import Cheetah.Filters as Filters
import Cheetah.ErrorCatchers as ErrorCatchers
from prewikka import User, utils
from prewikka.templates.MessageListing import MessageListing

##################################################
## MODULE CONSTANTS
try:
    True, False
except NameError:
    True, False = (1==1), (1==0)
VFFSL=valueFromFrameOrSearchList
VFSL=valueFromSearchList
VFN=valueForName
currentTime=time.time
__CHEETAH_version__ = '2.0.1'
__CHEETAH_versionTuple__ = (2, 0, 1, 'final', 0)
__CHEETAH_genTime__ = 1228925676.1597619
__CHEETAH_genTimestamp__ = 'Wed Dec 10 16:14:36 2008'
__CHEETAH_src__ = 'prewikka/templates/AlertListing.tmpl'
__CHEETAH_srcLastModified__ = 'Fri Mar 21 14:51:53 2008'
__CHEETAH_docstring__ = 'Autogenerated by CHEETAH: The Python-Powered Template Engine'

if __CHEETAH_versionTuple__ < RequiredCheetahVersionTuple:
    raise AssertionError(
      'This template was compiled with Cheetah version'
      ' %s. Templates compiled before version %s must be recompiled.'%(
         __CHEETAH_version__, RequiredCheetahVersion))

##################################################
## CLASSES

class AlertListing(MessageListing):

    ##################################################
    ## CHEETAH GENERATED METHODS


    def __init__(self, *args, **KWs):

        MessageListing.__init__(self, *args, **KWs)
        if not self._CHEETAH__instanceInitialized:
            cheetahKWArgs = {}
            allowedKWs = 'searchList namespaces filter filtersLib errorCatcher'.split()
            for k,v in KWs.items():
                if k in allowedKWs: cheetahKWArgs[k] = v
            self._initCheetahInstance(**cheetahKWArgs)
        

    def head_extra_content(self, **KWS):



        ## CHEETAH: generated from #block head_extra_content at line 4, col 1.
        trans = KWS.get("trans")
        if (not trans and not self._CHEETAH__isBuffering and not callable(self.transaction)):
            trans = self.transaction # is None unless self.awake() was called
        if not trans:
            trans = DummyTransaction()
            _dummyTrans = True
        else: _dummyTrans = False
        write = trans.response().write
        SL = self._CHEETAH__searchList
        _filter = self._CHEETAH__currentFilter
        
        ########################################
        ## START - generated method body
        
        _orig_filter_27184480 = _filter
        filterName = 'CleanOutput'
        if self._CHEETAH__filters.has_key("CleanOutput"):
            _filter = self._CHEETAH__currentFilter = self._CHEETAH__filters[filterName]
        else:
            _filter = self._CHEETAH__currentFilter = \
			self._CHEETAH__filters[filterName] = getattr(self._CHEETAH__filtersLib, filterName)(self).filter
        write('''
<script type="text/javascript">

<!-- 
function del_entry(link) {
\trow = link.parentNode.parentNode
\ttable = row.parentNode
\tif ( ! row.nextSibling ) {
                row.previousSibling.lastChild.appendChild(row.lastChild.firstChild)
\t}

\ttable.removeChild(row)\t
}

function end(row) {
\tfield = document.createElement("td")
\tfield.setAttribute("width", "11px")
\trow.appendChild(field)

\tif ( row.firstChild != row.lastChild ) {
\t\tlink = document.createElement("a")
\t\tlink.onclick = function(){ del_entry(this) }
\t\tcontent = document.createTextNode("-")
\t\tlink.appendChild(content)
\t\tfield.appendChild(link)\t\t
\t} else {
\t\tcontent = document.createTextNode(" ")
\t\tfield.appendChild(content)
\t}
}

function get_operator_option(select, operator)
{
''')
        _filter = self._CHEETAH__currentFilter = _orig_filter_27184480
        if False:
            _("Equal")
        if False:
            _("Lesser than")
        if False:
            _("Greater than")
        if False:
            _("Lesser or equal")
        if False:
            _("Greater or equal")
        if False:
            _("Substring")
        if False:
            _("Substring (case-insensitive)")
        if False:
            _("Regular expression")
        if False:
            _("Regular expression (case-insensitive)")
        for operator, desc in (("=", VFFSL(SL,"_",False)("Equal")), ("<", VFFSL(SL,"_",False)("Lesser than")), 
                          (">", VFFSL(SL,"_",False)("Greater than")), ("<=", VFFSL(SL,"_",False)("Lesser or equal")), 
                          (">=", VFFSL(SL,"_",False)("Greater or equal")), ("<>", VFFSL(SL,"_",False)("Substring")), 
			  ("<>*", VFFSL(SL,"_",False)("Substring (case-insensitive)")), ("~", VFFSL(SL,"_",False)("Regular expression")), ("~*", VFFSL(SL,"_",False)("Regular expression (case-insensitive)"))): # generated from line 40, col 1
            write('''        option = document.createElement("option")

        option.setAttribute("value", \'''')
            _v = VFFSL(SL,"operator",True) # '$operator' on line 46, col 39
            if _v is not None: write(_filter(_v, rawExpr='$operator')) # from line 46, col 39.
            write('''\')
\toption.setAttribute("title", \'''')
            _v = VFFSL(SL,"desc",True) # '$desc' on line 47, col 32
            if _v is not None: write(_filter(_v, rawExpr='$desc')) # from line 47, col 32.
            write("""')
        if ( operator == '""")
            _v = VFFSL(SL,"operator",True) # '$operator' on line 48, col 27
            if _v is not None: write(_filter(_v, rawExpr='$operator')) # from line 48, col 27.
            write('''\' ) {
                option.setAttribute("selected", "true")
        }
        option_value = document.createTextNode(\'''')
            _v = VFFSL(SL,"operator",True) # '$operator' on line 51, col 49
            if _v is not None: write(_filter(_v, rawExpr='$operator')) # from line 51, col 49.
            write("""')
        option.appendChild(option_value)
        select.appendChild(option)
""")
        _orig_filter_65812727 = _filter
        filterName = 'CleanOutput'
        if self._CHEETAH__filters.has_key("CleanOutput"):
            _filter = self._CHEETAH__currentFilter = self._CHEETAH__filters[filterName]
        else:
            _filter = self._CHEETAH__currentFilter = \
			self._CHEETAH__filters[filterName] = getattr(self._CHEETAH__filtersLib, filterName)(self).filter
        write('''
}



options_array = new Array()
functions_array = new Array()


function del_td(name, num)
{
        old = document.getElementById("td_" + name + num)
        if ( ! old )
                return

        row = old.parentNode
                
        td = document.createElement("td")
        td.setAttribute("id", "td_" + name + num)

        row.insertBefore(td, old)
        row.removeChild(old)
}


function filter_add_list(value, object, name, num) {
        td = document.getElementById("td_" + name + num)
        
        var opt;

        select = document.createElement("select")
        select.setAttribute("name", name + \'_value_\' + num)
        select.setAttribute("class", "popup_input_field")
        td.appendChild(select)
        
        for (key in options_array[object]) {
                option = document.createElement("option")
                
                if ( options_array[object][key] == value ) {
                        option.setAttribute("selected", "true")
                }
                
                option_value = document.createTextNode(options_array[object][key])
\t        option.appendChild(option_value)
\t        select.appendChild(option)
        }
}

function filter_add_input(value, object, name, num) {
        td = document.getElementById("td_" + name + num)
        
        input = document.createElement("input")
\tinput.setAttribute("class", "popup_input_field")
\tinput.setAttribute("name", name + \'_value_\' + num)
\tinput.setAttribute("type", "text")
\tinput.setAttribute("value", value)
        td.appendChild(input)
}



''')
        for category, aggregations in (
                          ("classification", VFFSL(SL,"classification_aggregations",True)),
                          ("analyzer", VFFSL(SL,"analyzer_aggregations",True)),
                          ("source", VFFSL(SL,"source_aggregations",True)),
                          ("target", VFFSL(SL,"target_aggregations",True))
): # generated from line 117, col 1
            write('''

function aggregated_''')
            _v = VFFSL(SL,"category",True) # '${category}' on line 125, col 21
            if _v is not None: write(_filter(_v, rawExpr='${category}')) # from line 125, col 21.
            write('''_add_entry(path) {
\ttable = document.getElementById("''')
            _v = VFFSL(SL,"category",True) # '${category}' on line 126, col 35
            if _v is not None: write(_filter(_v, rawExpr='${category}')) # from line 126, col 35.
            write('''_aggregation_table")

        if ( table.lastChild && table.lastChild.nodeName == "TR" ) {
                table.lastChild.lastChild.removeChild(table.lastChild.lastChild.lastChild)
        }

        row = document.createElement("tr")
        table.appendChild(row)

        field = document.createElement("th")
        row.appendChild(field)
        content = document.createTextNode("''')
            if False:
                _('Group entry by:')
            _v = VFFSL(SL,"_",False)('Group entry by:') # "$_('Group entry by:')" on line 137, col 44
            if _v is not None: write(_filter(_v, rawExpr="$_('Group entry by:')")) # from line 137, col 44.
            write('''")
        field.appendChild(content)

        field = document.createElement("td")
        row.appendChild(field)
        field = document.createElement("td")
        row.appendChild(field)

        field = document.createElement("td")
        row.appendChild(field)
        select = document.createElement("select")
        field.appendChild(select)

\tselect.setAttribute("class", "popup_input_field")
\tselect.setAttribute("name", "aggregated_''')
            _v = VFFSL(SL,"category",True) # '${category}' on line 151, col 42
            if _v is not None: write(_filter(_v, rawExpr='${category}')) # from line 151, col 42.
            write('''")
        
''')
            for aggregation_name, aggregated_path, unused in VFFSL(SL,"aggregations",True): # generated from line 153, col 9
                write('''
        option = document.createElement("option")

''')
                if VFFSL(SL,"aggregated_path",True) == None: # generated from line 157, col 1
                    write('''        option.setAttribute("disabled", "disabled")
''')
                else: # generated from line 159, col 1
                    write('''        option.setAttribute("value", \'''')
                    _v = VFFSL(SL,"aggregated_path",True) # '$aggregated_path' on line 160, col 39
                    if _v is not None: write(_filter(_v, rawExpr='$aggregated_path')) # from line 160, col 39.
                    write("""')
        if ( path == '""")
                    _v = VFFSL(SL,"aggregated_path",True) # '$aggregated_path' on line 161, col 23
                    if _v is not None: write(_filter(_v, rawExpr='$aggregated_path')) # from line 161, col 23.
                    write('''\' ) {
                option.setAttribute("selected", "true")
        }
''')
                write("""
\toption_value = document.createTextNode('""")
                _v = VFFSL(SL,"aggregation_name",True) # '$aggregation_name' on line 166, col 42
                if _v is not None: write(_filter(_v, rawExpr='$aggregation_name')) # from line 166, col 42.
                write("""')
\toption.appendChild(option_value)
\tselect.appendChild(option)
        
""")
            write('''
\tend(row)
\tfield = document.createElement("td")
\tfield.setAttribute("width", "11px")
\trow.appendChild(field)

\tlink = document.createElement("a")
\tlink.onclick = function(){ aggregated_''')
            _v = VFFSL(SL,"category",True) # '${category}' on line 178, col 40
            if _v is not None: write(_filter(_v, rawExpr='${category}')) # from line 178, col 40.
            write('''_add_entry(\'\') }
\tcontent = document.createTextNode("+")
\tlink.appendChild(content)
\tfield.appendChild(link)
}
''')
        write('''
''')
        for name, objects in (
			  ("classification", VFFSL(SL,"classification_filters",True)),
                          ("analyzer", VFFSL(SL,"analyzer_filters",True)), 
                          ("source", VFFSL(SL,"source_filters",True)),
                          ("target", VFFSL(SL,"target_filters",True)),
): # generated from line 185, col 1
            write('''
function ''')
            _v = VFFSL(SL,"name",True) # '${name}' on line 192, col 10
            if _v is not None: write(_filter(_v, rawExpr='${name}')) # from line 192, col 10.
            write("""_add_entry(object, operator, value, num) {
\ttable = document.getElementById('""")
            _v = VFFSL(SL,"name",True) # '${name}' on line 193, col 35
            if _v is not None: write(_filter(_v, rawExpr='${name}')) # from line 193, col 35.
            write('''_table\')

\tif ( table.lastChild && table.lastChild.nodeName == "TR" ) {
\t\ttable.lastChild.lastChild.removeChild(table.lastChild.lastChild.lastChild)
\t}

\trow = document.createElement("tr")
\ttable.appendChild(row)

\tfield = document.createElement("th")
\tcontent = document.createTextNode("''')
            if False:
                _('Filter on:')
            _v = VFFSL(SL,"_",False)('Filter on:') # "$_('Filter on:')" on line 203, col 37
            if _v is not None: write(_filter(_v, rawExpr="$_('Filter on:')")) # from line 203, col 37.
            write('''")
\tfield.appendChild(content)
\trow.appendChild(field)
\t
\tfield = document.createElement("td")
\trow.appendChild(field)
\tselect = document.createElement("select")
\tfield.appendChild(select)

\tselect.setAttribute("class", "popup_select_field")
\tselect.setAttribute("name", "''')
            _v = VFFSL(SL,"name",True) # '${name}' on line 213, col 31
            if _v is not None: write(_filter(_v, rawExpr='${name}')) # from line 213, col 31.
            write('''_object_" + num)
        select.onchange = function() { del_td(\'''')
            _v = VFFSL(SL,"name",True) # '${name}' on line 214, col 48
            if _v is not None: write(_filter(_v, rawExpr='${name}')) # from line 214, col 48.
            write("""', num); functions_array[this.options[this.selectedIndex].value](value, this.options[this.selectedIndex].value, '""")
            _v = VFFSL(SL,"name",True) # '${name}' on line 214, col 168
            if _v is not None: write(_filter(_v, rawExpr='${name}')) # from line 214, col 168.
            write("""', num) }
        
        var add_default
        var add_default_object
        
""")
            for object_name, object, obval in VFFSL(SL,"objects",True)        : # generated from line 219, col 1
                write('''\toption = document.createElement("option")

''')
                if VFFSL(SL,"obval",True) == None: # generated from line 222, col 1
                    write('''        func = filter_add_input
''')
                else: # generated from line 224, col 1
                    write('''        func = filter_add_list
        options_array["''')
                    _v = VFFSL(SL,"object",True) # '$object' on line 226, col 24
                    if _v is not None: write(_filter(_v, rawExpr='$object')) # from line 226, col 24.
                    write('''"] = new Array()

''')
                    cnt = 0
                    for opt in VFFSL(SL,"obval",True): # generated from line 229, col 9
                        write('''                options_array["''')
                        _v = VFFSL(SL,"object",True) # '$object' on line 230, col 32
                        if _v is not None: write(_filter(_v, rawExpr='$object')) # from line 230, col 32.
                        write('''"][''')
                        _v = VFFSL(SL,"cnt",True) # '$cnt' on line 230, col 42
                        if _v is not None: write(_filter(_v, rawExpr='$cnt')) # from line 230, col 42.
                        write("""] = '""")
                        _v = VFFSL(SL,"opt",True) # '${opt}' on line 230, col 51
                        if _v is not None: write(_filter(_v, rawExpr='${opt}')) # from line 230, col 51.
                        write("""'
""")
                        cnt += 1
                write('''
''')
                if VFFSL(SL,"object",True) == None: # generated from line 235, col 1
                    write('''\toption.setAttribute("disabled", "disabled")
\toption.setAttribute("value", \'\')
''')
                else: # generated from line 238, col 1
                    write('''\toption.setAttribute("value", \'''')
                    _v = VFFSL(SL,"object",True) # '$object' on line 239, col 32
                    if _v is not None: write(_filter(_v, rawExpr='$object')) # from line 239, col 32.
                    write("""')
\tif ( object == '""")
                    _v = VFFSL(SL,"object",True) # '$object' on line 240, col 18
                    if _v is not None: write(_filter(_v, rawExpr='$object')) # from line 240, col 18.
                    write('''\' || ! object ) {
\t\toption.setAttribute("selected", "true")
\t\tadd_default = func
\t\tadd_default_object = \'''')
                    _v = VFFSL(SL,"object",True) # '$object' on line 243, col 25
                    if _v is not None: write(_filter(_v, rawExpr='$object')) # from line 243, col 25.
                    write("""'
\t\tobject = '""")
                    _v = VFFSL(SL,"object",True) # '$object' on line 244, col 13
                    if _v is not None: write(_filter(_v, rawExpr='$object')) # from line 244, col 13.
                    write("""'
\t}
""")
                write("""
\toption_value = document.createTextNode('""")
                _v = VFFSL(SL,"object_name",True) # '$object_name' on line 248, col 42
                if _v is not None: write(_filter(_v, rawExpr='$object_name')) # from line 248, col 42.
                write('''\')
\toption.appendChild(option_value)
\tselect.appendChild(option)


        functions_array["''')
                _v = VFFSL(SL,"object",True) # '$object' on line 253, col 26
                if _v is not None: write(_filter(_v, rawExpr='$object')) # from line 253, col 26.
                write('''"] = func
''')
            write('''
        field = document.createElement("td")
        row.appendChild(field)        
        select = document.createElement("select")
        field.appendChild(select)
\tselect.setAttribute("class", "popup_operator_select")
        select.setAttribute("name", "''')
            _v = VFFSL(SL,"name",True) # '${name}' on line 261, col 38
            if _v is not None: write(_filter(_v, rawExpr='${name}')) # from line 261, col 38.
            write('''_operator_" + num)
        
        if ( ! operator )
                operator = "<>*";
                
        get_operator_option(select, operator)

\tfield = document.createElement("td")
\tfield.setAttribute("id", "td_''')
            _v = VFFSL(SL,"name",True) # '$name' on line 269, col 31
            if _v is not None: write(_filter(_v, rawExpr='$name')) # from line 269, col 31.
            write('''" + num)
\trow.appendChild(field)

        if (add_default) {
                add_default(value, add_default_object, \'''')
            _v = VFFSL(SL,"name",True) # '${name}' on line 273, col 57
            if _v is not None: write(_filter(_v, rawExpr='${name}')) # from line 273, col 57.
            write('''\', num);
        }
                
\tend(row)
\t
\tfield = document.createElement("td")
\tfield.setAttribute("width", "11px")
\trow.appendChild(field)
\tlink = document.createElement("a")
\tlink.onclick = function(){ ''')
            _v = VFFSL(SL,"name",True) # '${name}' on line 282, col 29
            if _v is not None: write(_filter(_v, rawExpr='${name}')) # from line 282, col 29.
            write('''_add_entry(\'\', \'\', \'\', (num + 1)) };
\tcontent = document.createTextNode("+")
\tlink.appendChild(content)
\tfield.appendChild(link)
}

''')
        write('''//--></script>

''')
        _filter = self._CHEETAH__currentFilter = _orig_filter_65812727
        _orig_filter_23333626 = _filter
        filterName = 'Filter'
        if self._CHEETAH__filters.has_key("Filter"):
            _filter = self._CHEETAH__currentFilter = self._CHEETAH__filters[filterName]
        else:
            _filter = self._CHEETAH__currentFilter = \
			self._CHEETAH__filters[filterName] = getattr(self._CHEETAH__filtersLib, filterName)(self).filter
        _filter = self._CHEETAH__currentFilter = _orig_filter_23333626
        
        ########################################
        ## END - generated method body
        
        return _dummyTrans and trans.response().getvalue() or ""
        

    def message_fields_header(self, **KWS):



        ## CHEETAH: generated from #block message_fields_header at line 297, col 1.
        trans = KWS.get("trans")
        if (not trans and not self._CHEETAH__isBuffering and not callable(self.transaction)):
            trans = self.transaction # is None unless self.awake() was called
        if not trans:
            trans = DummyTransaction()
            _dummyTrans = True
        else: _dummyTrans = False
        write = trans.response().write
        SL = self._CHEETAH__searchList
        _filter = self._CHEETAH__currentFilter
        
        ########################################
        ## START - generated method body
        
        write('''
<thead>
<tr style="height: 20px;">
  <th class="filter_popup">
    <a>''')
        if False:
            _("Classification")
        _v = VFFSL(SL,"_",False)("Classification") # '$_("Classification")' on line 302, col 8
        if _v is not None: write(_filter(_v, rawExpr='$_("Classification")')) # from line 302, col 8.
        write('''</a>
    <div id="classification">
     <table>
      <tr><td><table class="inline_filter_content"><tbody id="classification_table"></tbody></table></td></tr>
      <tr><td><table class="inline_filter_content"><tbody id="classification_aggregation_table"></tbody></table></td></tr>
      <tr><td>
      <table class="inline_filter_content">
      <tr>
       <th>''')
        if False:
            _("Type:")
        _v = VFFSL(SL,"_",False)("Type:") # '$_("Type:")' on line 310, col 12
        if _v is not None: write(_filter(_v, rawExpr='$_("Type:")')) # from line 310, col 12.
        write('''</th>
       <td>&nbsp;</td>
''')
        if VFFSL(SL,"correlation_alert_view",True): # generated from line 312, col 7
            disabled = "disabled=\"disabled\""
        else: # generated from line 314, col 7
            disabled = ""
        write('''      
      ''')
        if False:
            N_("Alert")
        if False:
            N_("CorrelationAlert")
        if False:
            N_("OverflowAlert")
        if False:
            N_("ToolAlert")
        for name, path in ((VFFSL(SL,"N_",False)("Alert"), "alert.create_time"), (VFFSL(SL,"N_",False)("CorrelationAlert"), "alert.correlation_alert.name"), 
                          (VFFSL(SL,"N_",False)("OverflowAlert"), "alert.overflow_alert.program"), (VFFSL(SL,"N_",False)("ToolAlert"), "alert.tool_alert.name")): # generated from line 318, col 7
            if path in VFFSL(SL,"alert.type",True): # generated from line 320, col 9
                checked = "checked='checked'"
            else: # generated from line 322, col 9
                checked = ""
            write('''        
        <td>''')
            if False:
                _(VFFSL(SL,"name",True))
            _v = VFFSL(SL,"_",False)(VFFSL(SL,"name",True)) # '$_($name)' on line 326, col 13
            if _v is not None: write(_filter(_v, rawExpr='$_($name)')) # from line 326, col 13.
            write('''<input class="checkbox" ''')
            _v = VFFSL(SL,"disabled",True) # '$disabled' on line 326, col 46
            if _v is not None: write(_filter(_v, rawExpr='$disabled')) # from line 326, col 46.
            write(''' type="checkbox" name="alert.type" value="''')
            _v = VFFSL(SL,"path",True) # '$path' on line 326, col 97
            if _v is not None: write(_filter(_v, rawExpr='$path')) # from line 326, col 97.
            write('''" ''')
            _v = VFFSL(SL,"checked",True) # '$checked' on line 326, col 104
            if _v is not None: write(_filter(_v, rawExpr='$checked')) # from line 326, col 104.
            write(''' /></td>
''')
        write('''      </tr>


      <tr>
       <th>''')
        if False:
            _("Severity:")
        _v = VFFSL(SL,"_",False)("Severity:") # '$_("Severity:")' on line 332, col 12
        if _v is not None: write(_filter(_v, rawExpr='$_("Severity:")')) # from line 332, col 12.
        write('''</th>
      ''')
        if False:
            N_("info")
        if False:
            N_("low")
        if False:
            N_("medium")
        if False:
            N_("high")
        if False:
            N_("none")
        for item in VFFSL(SL,"N_",False)("info"), VFFSL(SL,"N_",False)("low"), VFFSL(SL,"N_",False)("medium"), VFFSL(SL,"N_",False)("high"), VFFSL(SL,"N_",False)("none"): # generated from line 333, col 7
            if VFFSL(SL,"item",True) in VFFSL(SL,"alert.assessment.impact.severity",True): # generated from line 334, col 9
                checked = "checked='checked'"
            else: # generated from line 336, col 9
                checked = ""
            write('''        <td>''')
            if False:
                _(VFFSL(SL,"item",True))
            _v = VFFSL(SL,"_",False)(VFFSL(SL,"item",True)) # '$_($item)' on line 339, col 13
            if _v is not None: write(_filter(_v, rawExpr='$_($item)')) # from line 339, col 13.
            write('''<input class="checkbox" type="checkbox" name="alert.assessment.impact.severity" value="''')
            _v = VFFSL(SL,"item",True) # '$item' on line 339, col 109
            if _v is not None: write(_filter(_v, rawExpr='$item')) # from line 339, col 109.
            write('''" ''')
            _v = VFFSL(SL,"checked",True) # '$checked' on line 339, col 116
            if _v is not None: write(_filter(_v, rawExpr='$checked')) # from line 339, col 116.
            write(''' /></td>
''')
        write('''      </tr>

      <tr>
       <th>''')
        if False:
            _("Completion:")
        _v = VFFSL(SL,"_",False)("Completion:") # '$_("Completion:")' on line 344, col 12
        if _v is not None: write(_filter(_v, rawExpr='$_("Completion:")')) # from line 344, col 12.
        write('''</th>  
       <td colspan="2">&nbsp;</td>
       
      ''')
        if False:
            N_("succeeded")
        if False:
            N_("failed")
        if False:
            N_("none")
        for item in VFFSL(SL,"N_",False)("succeeded"), VFFSL(SL,"N_",False)("failed"), VFFSL(SL,"N_",False)("none"): # generated from line 347, col 7
            if item in VFFSL(SL,"alert.assessment.impact.completion",True): # generated from line 348, col 9
                checked = "checked='checked'"
            else: # generated from line 350, col 9
                checked = ""
            write('''        <td>''')
            if False:
                _(VFFSL(SL,"item",True))
            _v = VFFSL(SL,"_",False)(VFFSL(SL,"item",True)) # '$_($item)' on line 353, col 13
            if _v is not None: write(_filter(_v, rawExpr='$_($item)')) # from line 353, col 13.
            write('''<input class="checkbox" type="checkbox" name="alert.assessment.impact.completion" value="''')
            _v = VFFSL(SL,"item",True) # '$item' on line 353, col 111
            if _v is not None: write(_filter(_v, rawExpr='$item')) # from line 353, col 111.
            write('''" ''')
            _v = VFFSL(SL,"checked",True) # '$checked' on line 353, col 118
            if _v is not None: write(_filter(_v, rawExpr='$checked')) # from line 353, col 118.
            write(''' /></td>
''')
        write('''      
    </tr>
    </table>
      </td></tr>
     </table>

      <script type="text/javascript">
''')
        cnt = 0
        for object, operator, value in VFFSL(SL,"classification",True): # generated from line 363, col 9
            write('''          classification_add_entry("''')
            _v = VFFSL(SL,"object",True) # '$object' on line 364, col 37
            if _v is not None: write(_filter(_v, rawExpr='$object')) # from line 364, col 37.
            write('''", "''')
            _v = VFFSL(SL,"operator",True) # '$operator' on line 364, col 48
            if _v is not None: write(_filter(_v, rawExpr='$operator')) # from line 364, col 48.
            write('''", "''')
            _v = VFN(VFFSL(SL,"utils",True),"escape_attribute",False)(VFFSL(SL,"value",True)) # '$utils.escape_attribute($value)' on line 364, col 61
            if _v is not None: write(_filter(_v, rawExpr='$utils.escape_attribute($value)')) # from line 364, col 61.
            write('''", ''')
            _v = VFFSL(SL,"cnt",True) # '$cnt' on line 364, col 95
            if _v is not None: write(_filter(_v, rawExpr='$cnt')) # from line 364, col 95.
            write(''')
''')
            cnt = VFFSL(SL,"cnt",True) + 1
        write('''
''')
        if len(VFFSL(SL,"aggregated_classification",True)) == 0: # generated from line 368, col 7
            write('''        aggregated_classification_add_entry("")
''')
        else: # generated from line 370, col 7
            for path in VFFSL(SL,"aggregated_classification",True): # generated from line 371, col 9
                write("""          aggregated_classification_add_entry('""")
                _v = VFFSL(SL,"path",True) # '$path' on line 372, col 48
                if _v is not None: write(_filter(_v, rawExpr='$path')) # from line 372, col 48.
                write("""')
""")
        write('''      </script>
    </div>

''')
        if VFFSL(SL,"classification_filtered",True): # generated from line 378, col 5
            write('''      <span class="filter_enabled_marker">*</span>
''')
        write('''  </th>

  <th class="filter_popup">
    <a>''')
        if False:
            _("Source")
        _v = VFFSL(SL,"_",False)("Source") # '$_("Source")' on line 384, col 8
        if _v is not None: write(_filter(_v, rawExpr='$_("Source")')) # from line 384, col 8.
        write('''</a>
    <div id="source">
     <table>
      <tr><td><table class="inline_filter_content"><tbody id="source_table"></tbody></table></td></tr>
      <tr><td><table class="inline_filter_content"><tbody id="source_aggregation_table"></tbody></table></td></tr>
     </table>
     
     <script type="text/javascript">
''')
        cnt = 0
        for object, operator, value in VFFSL(SL,"source",True): # generated from line 393, col 9
            write('''          source_add_entry("''')
            _v = VFFSL(SL,"object",True) # '$object' on line 394, col 29
            if _v is not None: write(_filter(_v, rawExpr='$object')) # from line 394, col 29.
            write('''", "''')
            _v = VFFSL(SL,"operator",True) # '$operator' on line 394, col 40
            if _v is not None: write(_filter(_v, rawExpr='$operator')) # from line 394, col 40.
            write('''", "''')
            _v = VFN(VFFSL(SL,"utils",True),"escape_attribute",False)(VFFSL(SL,"value",True)) # '$utils.escape_attribute($value)' on line 394, col 53
            if _v is not None: write(_filter(_v, rawExpr='$utils.escape_attribute($value)')) # from line 394, col 53.
            write('''", ''')
            _v = VFFSL(SL,"cnt",True) # '$cnt' on line 394, col 87
            if _v is not None: write(_filter(_v, rawExpr='$cnt')) # from line 394, col 87.
            write(''')
''')
            cnt += 1
        write('''
''')
        if len(VFFSL(SL,"aggregated_source",True)) == 0: # generated from line 398, col 7
            write('''        aggregated_source_add_entry("")
''')
        else: # generated from line 400, col 7
            for path in VFFSL(SL,"aggregated_source",True): # generated from line 401, col 9
                write("""          aggregated_source_add_entry('""")
                _v = VFFSL(SL,"path",True) # '$path' on line 402, col 40
                if _v is not None: write(_filter(_v, rawExpr='$path')) # from line 402, col 40.
                write("""')
""")
        write('''     </script>
    </div>
''')
        if VFFSL(SL,"source_filtered",True): # generated from line 407, col 5
            write('''      <span class="filter_enabled_marker">*</span>
''')
        write('''  </th>

  <th class="filter_popup">
    <a>''')
        if False:
            _("Target")
        _v = VFFSL(SL,"_",False)("Target") # '$_("Target")' on line 413, col 8
        if _v is not None: write(_filter(_v, rawExpr='$_("Target")')) # from line 413, col 8.
        write('''</a>
    <div id="target">
     <table>
      <tr><td><table class="inline_filter_content"><tbody id="target_table"></tbody></table></td></tr>
      <tr><td><table class="inline_filter_content"><tbody id="target_aggregation_table"></tbody></table></td></tr>
     </table>
     <script type="text/javascript">
''')
        cnt = 0
        for object, operator, value in VFFSL(SL,"target",True): # generated from line 421, col 9
            write('''          target_add_entry("''')
            _v = VFFSL(SL,"object",True) # '$object' on line 422, col 29
            if _v is not None: write(_filter(_v, rawExpr='$object')) # from line 422, col 29.
            write('''", "''')
            _v = VFFSL(SL,"operator",True) # '$operator' on line 422, col 40
            if _v is not None: write(_filter(_v, rawExpr='$operator')) # from line 422, col 40.
            write('''", "''')
            _v = VFN(VFFSL(SL,"utils",True),"escape_attribute",False)(VFFSL(SL,"value",True)) # '$utils.escape_attribute($value)' on line 422, col 53
            if _v is not None: write(_filter(_v, rawExpr='$utils.escape_attribute($value)')) # from line 422, col 53.
            write('''", ''')
            _v = VFFSL(SL,"cnt",True) # '$cnt' on line 422, col 87
            if _v is not None: write(_filter(_v, rawExpr='$cnt')) # from line 422, col 87.
            write(''')
''')
            cnt = VFFSL(SL,"cnt",True) + 1
        write('''
''')
        if len(VFFSL(SL,"aggregated_target",True)) == 0: # generated from line 426, col 7
            write('''        aggregated_target_add_entry("")
''')
        else: # generated from line 428, col 7
            for path in VFFSL(SL,"aggregated_target",True): # generated from line 429, col 9
                write("""          aggregated_target_add_entry('""")
                _v = VFFSL(SL,"path",True) # '$path' on line 430, col 40
                if _v is not None: write(_filter(_v, rawExpr='$path')) # from line 430, col 40.
                write("""')
""")
        write('''     </script>
    </div>
''')
        if VFFSL(SL,"target_filtered",True): # generated from line 435, col 5
            write('''      <span class="filter_enabled_marker">*</span>
''')
        write('''  </th>
  
  <th class="filter_popup">
    <a>''')
        if False:
            _("Sensor")
        _v = VFFSL(SL,"_",False)("Sensor") # '$_("Sensor")' on line 441, col 8
        if _v is not None: write(_filter(_v, rawExpr='$_("Sensor")')) # from line 441, col 8.
        write('''</a>
    <div id="analyzer">
     <table>
      <tr><td><table class="inline_filter_content"><tbody id="analyzer_table"></tbody></table></td></tr>
      <tr><td><table class="inline_filter_content"><tbody id="analyzer_aggregation_table"></tbody></table></td></tr>
     </table>

     <script  type="text/javascript">
''')
        cnt = 0
        for object, operator, value in VFFSL(SL,"analyzer",True): # generated from line 450, col 7
            write('''       analyzer_add_entry("''')
            _v = VFFSL(SL,"object",True) # '$object' on line 451, col 28
            if _v is not None: write(_filter(_v, rawExpr='$object')) # from line 451, col 28.
            write('''", "''')
            _v = VFFSL(SL,"operator",True) # '$operator' on line 451, col 39
            if _v is not None: write(_filter(_v, rawExpr='$operator')) # from line 451, col 39.
            write('''", "''')
            _v = VFN(VFFSL(SL,"utils",True),"escape_attribute",False)(VFFSL(SL,"value",True)) # '$utils.escape_attribute($value)' on line 451, col 52
            if _v is not None: write(_filter(_v, rawExpr='$utils.escape_attribute($value)')) # from line 451, col 52.
            write('''", ''')
            _v = VFFSL(SL,"cnt",True) # '$cnt' on line 451, col 86
            if _v is not None: write(_filter(_v, rawExpr='$cnt')) # from line 451, col 86.
            write(''')
''')
            cnt = VFFSL(SL,"cnt",True) + 1
        write('''
''')
        if len(VFFSL(SL,"aggregated_analyzer",True)) == 0: # generated from line 455, col 7
            write('''        aggregated_analyzer_add_entry("")
''')
        else: # generated from line 457, col 7
            for path in VFFSL(SL,"aggregated_analyzer",True): # generated from line 458, col 9
                write("""          aggregated_analyzer_add_entry('""")
                _v = VFFSL(SL,"path",True) # '$path' on line 459, col 42
                if _v is not None: write(_filter(_v, rawExpr='$path')) # from line 459, col 42.
                write("""')
""")
        write('''     </script>
    </div>
''')
        if VFFSL(SL,"analyzer_filtered",True): # generated from line 464, col 5
            write('''      <span class="filter_enabled_marker">*</span>
''')
        write('''  </th>

  <td>''')
        if False:
            _("Time")
        _v = VFFSL(SL,"_",False)("Time") # '$_("Time")' on line 469, col 7
        if _v is not None: write(_filter(_v, rawExpr='$_("Time")')) # from line 469, col 7.
        write('''</td>
</tr>
</thead>
''')
        
        ########################################
        ## END - generated method body
        
        return _dummyTrans and trans.response().getvalue() or ""
        

    def message_fields(self, **KWS):



        ## CHEETAH: generated from #block message_fields at line 475, col 1.
        trans = KWS.get("trans")
        if (not trans and not self._CHEETAH__isBuffering and not callable(self.transaction)):
            trans = self.transaction # is None unless self.awake() was called
        if not trans:
            trans = DummyTransaction()
            _dummyTrans = True
        else: _dummyTrans = False
        write = trans.response().write
        SL = self._CHEETAH__searchList
        _filter = self._CHEETAH__currentFilter
        
        ########################################
        ## START - generated method body
        
        _orig_filter_40489839 = _filter
        filterName = 'CleanOutput'
        if self._CHEETAH__filters.has_key("CleanOutput"):
            _filter = self._CHEETAH__currentFilter = self._CHEETAH__filters[filterName]
        else:
            _filter = self._CHEETAH__currentFilter = \
			self._CHEETAH__filters[filterName] = getattr(self._CHEETAH__filtersLib, filterName)(self).filter
        write('''
<td>
''')
        if VFFSL(SL,"message.sub_alert_name",True): # generated from line 479, col 3
            write('''    <b>''')
            _v = VFFSL(SL,"message.sub_alert_type",True) # '$message.sub_alert_type' on line 480, col 8
            if _v is not None: write(_filter(_v, rawExpr='$message.sub_alert_type')) # from line 480, col 8.
            if VFFSL(SL,"message.sub_alert_display",True): # generated from line 481, col 5
                write('''      ''')
                if False:
                    ngettext("alert", "alerts", VFFSL(SL,"message.sub_alert_number",True))
                string = VFFSL(SL,"ngettext",False)("alert", "alerts", VFFSL(SL,"message.sub_alert_number",True))
                write('''      (<a href="''')
                _v = VFFSL(SL,"message.sub_alert_display",True) # '$message.sub_alert_display' on line 483, col 17
                if _v is not None: write(_filter(_v, rawExpr='$message.sub_alert_display')) # from line 483, col 17.
                write('''">''')
                _v = VFFSL(SL,"message.sub_alert_number",True) # '$message.sub_alert_number' on line 483, col 45
                if _v is not None: write(_filter(_v, rawExpr='$message.sub_alert_number')) # from line 483, col 45.
                write('''</a> ''')
                _v = VFFSL(SL,"string",True) # '$string' on line 483, col 75
                if _v is not None: write(_filter(_v, rawExpr='$string')) # from line 483, col 75.
                write(''')''')
            write(''':</b> <i><a href="''')
            _v = VFFSL(SL,"message.sub_alert_link",True) # '$message.sub_alert_link' on line 485, col 19
            if _v is not None: write(_filter(_v, rawExpr='$message.sub_alert_link')) # from line 485, col 19.
            write('''">''')
            _v = VFFSL(SL,"message.sub_alert_name",True) # '$message.sub_alert_name' on line 485, col 44
            if _v is not None: write(_filter(_v, rawExpr='$message.sub_alert_name')) # from line 485, col 44.
            write('''</a></i><br/>''')
        write('''
''')
        if VFFSL(SL,"message.aggregated",True) and VFFSL(SL,"message.aggregated_classifications_hidden",True) > 0: # generated from line 488, col 3
            write('''    ''')
            if False:
                _("%(hidden)d of %(total)d alerts not shown...")
            string = VFFSL(SL,"_",False)("%(hidden)d of %(total)d alerts not shown...")
            write('''    <b>(''')
            _v = VFFSL(SL,"str",False)(VFFSL(SL,"string",True) % { "hidden": VFFSL(SL,"message.aggregated_classifications_hidden",True), "total": VFFSL(SL,"message.aggregated_classifications_total",True) }) # '$str($string % { "hidden": $message.aggregated_classifications_hidden, "total": $message.aggregated_classifications_total })' on line 490, col 9
            if _v is not None: write(_filter(_v, rawExpr='$str($string % { "hidden": $message.aggregated_classifications_hidden, "total": $message.aggregated_classifications_total })')) # from line 490, col 9.
            write('''
    <a href="''')
            _v = VFFSL(SL,"message.aggregated_classifications_hidden_expand",True) # '$message.aggregated_classifications_hidden_expand' on line 491, col 14
            if _v is not None: write(_filter(_v, rawExpr='$message.aggregated_classifications_hidden_expand')) # from line 491, col 14.
            write('''">''')
            if False:
                _("expand")
            _v = VFFSL(SL,"_",False)("expand") # '$_("expand")' on line 491, col 65
            if _v is not None: write(_filter(_v, rawExpr='$_("expand")')) # from line 491, col 65.
            write('''</a>)</b>
    <br/>
''')
        write('''
''')
        for info in VFFSL(SL,"message.infos",True): # generated from line 495, col 3
            if VFFSL(SL,"message.aggregated",True) and (len(VFFSL(SL,"message.infos",True)) > 1 or VFFSL(SL,"info.count",True) > 1): # generated from line 496, col 5
                write('''      ''')
                _v = VFFSL(SL,"info.count",True) # '$info.count' on line 497, col 7
                if _v is not None: write(_filter(_v, rawExpr='$info.count')) # from line 497, col 7.
                write(''' x
''')
            write('''    
''')
            if VFFSL(SL,"info.classification.value",True): # generated from line 500, col 5
                write('''      <a class="impact_severity_''')
                _v = VFFSL(SL,"info.severity.value",True) # '$info.severity.value' on line 501, col 33
                if _v is not None: write(_filter(_v, rawExpr='$info.severity.value')) # from line 501, col 33.
                write('''" href="''')
                _v = VFFSL(SL,"info.display",True) # '$info.display' on line 501, col 61
                if _v is not None: write(_filter(_v, rawExpr='$info.display')) # from line 501, col 61.
                write('''">''')
                _v = VFFSL(SL,"info.classification.value",True) # '$info.classification.value' on line 501, col 76
                if _v is not None: write(_filter(_v, rawExpr='$info.classification.value')) # from line 501, col 76.
                write('''</a>
''')
            else: # generated from line 502, col 5
                write('''      <a class="impact_severity_''')
                _v = VFFSL(SL,"info.severity.value",True) # '$info.severity.value' on line 503, col 33
                if _v is not None: write(_filter(_v, rawExpr='$info.severity.value')) # from line 503, col 33.
                write('''" href="''')
                _v = VFFSL(SL,"info.display",True) # '$info.display' on line 503, col 61
                if _v is not None: write(_filter(_v, rawExpr='$info.display')) # from line 503, col 61.
                write('''">n/a</a>
''')
            write('''
''')
            if VFFSL(SL,"info.completion.value",True): # generated from line 506, col 5
                write('''      (<span class="impact_completion_''')
                _v = VFFSL(SL,"info.completion.value",True) # '$info.completion.value' on line 507, col 39
                if _v is not None: write(_filter(_v, rawExpr='$info.completion.value')) # from line 507, col 39.
                write('''">''')
                _v = VFFSL(SL,"info.completion.value",True) # '$info.completion.value' on line 507, col 63
                if _v is not None: write(_filter(_v, rawExpr='$info.completion.value')) # from line 507, col 63.
                write('''</span>)
''')
            write('''
    <br/>
''')
            sep = "("
            for url, name in VFFSL(SL,"info.classification_references",True): # generated from line 512, col 1
                if VFFSL(SL,"url",True): # generated from line 513, col 1
                    _v = VFFSL(SL,"sep",True) # '$sep' on line 513, col 10
                    if _v is not None: write(_filter(_v, rawExpr='$sep')) # from line 513, col 10.
                    write('''<a target="''')
                    _v = VFFSL(SL,"prewikka.external_link_target",True) # '$prewikka.external_link_target' on line 513, col 25
                    if _v is not None: write(_filter(_v, rawExpr='$prewikka.external_link_target')) # from line 513, col 25.
                    write('''" href="''')
                    _v = VFFSL(SL,"url",True) # '$url' on line 513, col 63
                    if _v is not None: write(_filter(_v, rawExpr='$url')) # from line 513, col 63.
                    write('''">''')
                    _v = VFFSL(SL,"name",True) # '$name' on line 513, col 69
                    if _v is not None: write(_filter(_v, rawExpr='$name')) # from line 513, col 69.
                    write('''</a>''')
                else: # generated from line 513, col 78
                    _v = VFFSL(SL,"sep",True) # '$sep' on line 513, col 84
                    if _v is not None: write(_filter(_v, rawExpr='$sep')) # from line 513, col 84.
                    _v = VFFSL(SL,"name",True) # '$name' on line 513, col 88
                    if _v is not None: write(_filter(_v, rawExpr='$name')) # from line 513, col 88.
                sep = ", "
            if VFFSL(SL,"info.classification_references",True): # generated from line 515, col 10
                write(''')''')
            write('''
''')
        write('''</td>

''')
        if False:
            _("source")
        if False:
            _("target")
        for name, direction, hidden, total, expand in (VFFSL(SL,"_",False)("source"), VFFSL(SL,"message.source",True), VFFSL(SL,"message.aggregated_source_hidden",True), VFFSL(SL,"message.aggregated_source_total",True), VFFSL(SL,"message.aggregated_source_expand",True)), (VFFSL(SL,"_",False)("target"), VFFSL(SL,"message.target",True), VFFSL(SL,"message.aggregated_target_hidden",True), VFFSL(SL,"message.aggregated_target_total",True), VFFSL(SL,"message.aggregated_target_expand",True)): # generated from line 519, col 1
            write('''<td>
''')
            if len(VFFSL(SL,"direction",True)) == 0: # generated from line 521, col 1
                write('''       n/a
''')
            write('''
''')
            need_hr = 0
            write('''
''')
            if VFFSL(SL,"hidden",True) > 0: # generated from line 527, col 1
                write('''       ''')
                if False:
                    _("%(hidden)d of %(total)d %(name)ss not shown...")
                string = VFFSL(SL,"_",False)("%(hidden)d of %(total)d %(name)ss not shown...")
                write('''       <b>(''')
                _v = VFFSL(SL,"str",False)(VFFSL(SL,"string",True) % { "hidden": VFFSL(SL,"hidden",True), "total": VFFSL(SL,"total",True), "name": VFFSL(SL,"name",True) }) # '$str($string % { "hidden": $hidden, "total": $total, "name": $name })' on line 529, col 12
                if _v is not None: write(_filter(_v, rawExpr='$str($string % { "hidden": $hidden, "total": $total, "name": $name })')) # from line 529, col 12.
                write('''
       <a href="''')
                _v = VFFSL(SL,"expand",True) # '$expand' on line 530, col 17
                if _v is not None: write(_filter(_v, rawExpr='$expand')) # from line 530, col 17.
                write('''">''')
                if False:
                    _("expand")
                _v = VFFSL(SL,"_",False)("expand") # '$_("expand")' on line 530, col 26
                if _v is not None: write(_filter(_v, rawExpr='$_("expand")')) # from line 530, col 26.
                write('''</a>)</b>
       <br/>
''')
            write('''
''')
            for direction in VFFSL(SL,"direction",True) : # generated from line 534, col 1
                if VFFSL(SL,"need_hr",True): # generated from line 535, col 7
                    write('''\t<hr style="border: 1px dashed #808080; margin-top: 3px; margin-bottom: 0px;" />
''')
                write('''
''')
                need_hr = 1
                service = ""
                proto_param = ""
                proto_str = ""
                write('''    
''')
                if VFFSL(SL,"direction.protocol.value",True) != None: # generated from line 544, col 7
                    proto_str = VFN(VFFSL(SL,"direction.protocol.value",True),"lower",False)()
                    proto_param = "&amp;protocol=" + VFN(VFFSL(SL,"direction.protocol.value",True),"upper",False)()
                write('''
''')
                for address in VFFSL(SL,"direction.addresses",True): # generated from line 549, col 7
                    write('''       <a class="popup_menu_toggle">''')
                    _v = VFFSL(SL,"address.hostname",True) # '$address.hostname' on line 550, col 37
                    if _v is not None: write(_filter(_v, rawExpr='$address.hostname')) # from line 550, col 37.
                    write('''</a><span class="popup_menu">
         - <a href="''')
                    _v = VFFSL(SL,"address.inline_filter",True) # '$address.inline_filter' on line 551, col 21
                    if _v is not None: write(_filter(_v, rawExpr='$address.inline_filter')) # from line 551, col 21.
                    write('''">''')
                    if False:
                        _("Filter on this %s")
                    _v = VFFSL(SL,"str",False)(VFFSL(SL,"_",False)("Filter on this %s") % (VFFSL(SL,"name",True))) # '$str($_("Filter on this %s") % ($name))' on line 551, col 45
                    if _v is not None: write(_filter(_v, rawExpr='$str($_("Filter on this %s") % ($name))')) # from line 551, col 45.
                    write('''</a><br />

''')
                    if not VFFSL(SL,"address.category",True) or VFFSL(SL,"address.category",True) in ("ipv4-addr", "ipv4-net", "ipv6-addr", "ipv6-net"): # generated from line 553, col 8
                        write('''         - <a target="''')
                        _v = VFFSL(SL,"prewikka.external_link_target",True) # '$prewikka.external_link_target' on line 554, col 23
                        if _v is not None: write(_filter(_v, rawExpr='$prewikka.external_link_target')) # from line 554, col 23.
                        write('''" href="https://www.prelude-ids.com/host_details.php?host=''')
                        _v = VFFSL(SL,"address.value",True) # '$address.value' on line 554, col 111
                        if _v is not None: write(_filter(_v, rawExpr='$address.value')) # from line 554, col 111.
                        write('''">''')
                        if False:
                            _("%s information")
                        _v = VFN(VFFSL(SL,"str",False)(VFFSL(SL,"_",False)("%s information") % (VFFSL(SL,"name",True))),"capitalize",False)() # '$str($_("%s information") % ($name)).capitalize()' on line 554, col 127
                        if _v is not None: write(_filter(_v, rawExpr='$str($_("%s information") % ($name)).capitalize()')) # from line 554, col 127.
                        write('''</a><br />

''')
                        for cmdname, link in VFFSL(SL,"address.host_commands",True): # generated from line 556, col 11
                            write('''         - <a href="''')
                            _v = VFFSL(SL,"link",True) # '$link' on line 557, col 21
                            if _v is not None: write(_filter(_v, rawExpr='$link')) # from line 557, col 21.
                            write('''">''')
                            _v = VFFSL(SL,"cmdname",True) # '$cmdname' on line 557, col 28
                            if _v is not None: write(_filter(_v, rawExpr='$cmdname')) # from line 557, col 28.
                            write('''</a><br />
''')
                    write('''       </span>''')
                    if VFFSL(SL,"direction.service.value",True) != None: # generated from line 561, col 1
                        write(''':<a target="''')
                        _v = VFFSL(SL,"prewikka.external_link_target",True) # '$prewikka.external_link_target' on line 561, col 50
                        if _v is not None: write(_filter(_v, rawExpr='$prewikka.external_link_target')) # from line 561, col 50.
                        write('''" href="https://www.prelude-ids.com/port_details.php?port=''')
                        _v = VFFSL(SL,"str",False)(VFFSL(SL,"direction.service.value",True)) # '$str($direction.service.value)' on line 561, col 138
                        if _v is not None: write(_filter(_v, rawExpr='$str($direction.service.value)')) # from line 561, col 138.
                        _v = VFFSL(SL,"proto_param",True) # '$proto_param' on line 561, col 168
                        if _v is not None: write(_filter(_v, rawExpr='$proto_param')) # from line 561, col 168.
                        write('''">''')
                        _v = VFFSL(SL,"str",False)(VFFSL(SL,"direction.service.value",True)) # '$str($direction.service.value)' on line 561, col 182
                        if _v is not None: write(_filter(_v, rawExpr='$str($direction.service.value)')) # from line 561, col 182.
                        if VFFSL(SL,"proto_str",True): # generated from line 562, col 10
                            write('''/''')
                            _v = VFFSL(SL,"proto_str",True) # '$proto_str' on line 563, col 2
                            if _v is not None: write(_filter(_v, rawExpr='$proto_str')) # from line 563, col 2.
                            write('''</a>
''')
                        else : # generated from line 564, col 10
                            write('''</a>
''')
                    elif VFFSL(SL,"proto_str",True): # generated from line 567, col 8
                        write(''':''')
                        _v = VFFSL(SL,"proto_str",True) # '$proto_str' on line 568, col 2
                        if _v is not None: write(_filter(_v, rawExpr='$proto_str')) # from line 568, col 2.
                        write('''
''')
                    write('''<br />
''')
                write('''     
''')
                if VFFSL(SL,"len",False)(VFFSL(SL,"direction.addresses",True)) == 0 and VFFSL(SL,"service",True): # generated from line 573, col 7
                    write('''\tservice: ''')
                    _v = VFFSL(SL,"service",True)[1:] # '$service[1:]' on line 574, col 11
                    if _v is not None: write(_filter(_v, rawExpr='$service[1:]')) # from line 574, col 11.
                    write('''
''')
                write('''
''')
                cnt = 0
                for name, value, extra in VFFSL(SL,"direction.listed_values",True): # generated from line 578, col 6
                    if VFFSL(SL,"cnt",True) > 0: # generated from line 579, col 10
                        write('''          <br />
''')
                    write('''
         ''')
                    _v = VFFSL(SL,"name",True) # '$name' on line 583, col 10
                    if _v is not None: write(_filter(_v, rawExpr='$name')) # from line 583, col 10.
                    write(''': <a href="''')
                    _v = VFFSL(SL,"value.inline_filter",True) # '$value.inline_filter' on line 583, col 26
                    if _v is not None: write(_filter(_v, rawExpr='$value.inline_filter')) # from line 583, col 26.
                    write('''">''')
                    _v = VFFSL(SL,"value.value",True) # '$value.value' on line 583, col 48
                    if _v is not None: write(_filter(_v, rawExpr='$value.value')) # from line 583, col 48.
                    write('''</a>
''')
                    if VFFSL(SL,"extra",True) != None: # generated from line 584, col 10
                        write('''          (''')
                        _v = VFFSL(SL,"extra",True) # '$extra' on line 585, col 12
                        if _v is not None: write(_filter(_v, rawExpr='$extra')) # from line 585, col 12.
                        write(''')
''')
                    write('''         
''')
                    cnt += 1
            write('''
</td>
''')
        write('''
<td>
''')
        for sensor in VFFSL(SL,"message.sensors",True): # generated from line 596, col 3
            if VFFSL(SL,"sensor.name.value",True): # generated from line 597, col 5
                write('''      <a href="''')
                _v = VFFSL(SL,"sensor.name.inline_filter",True) # '$sensor.name.inline_filter' on line 598, col 16
                if _v is not None: write(_filter(_v, rawExpr='$sensor.name.inline_filter')) # from line 598, col 16.
                write('''">''')
                _v = VFFSL(SL,"sensor.name.value",True) # '$sensor.name.value' on line 598, col 44
                if _v is not None: write(_filter(_v, rawExpr='$sensor.name.value')) # from line 598, col 44.
                write('''</a>
''')
            if VFFSL(SL,"sensor.node_name.value",True): # generated from line 600, col 5
                write('''      (<a href="''')
                _v = VFFSL(SL,"sensor.node_name.inline_filter",True) # '$sensor.node_name.inline_filter' on line 601, col 17
                if _v is not None: write(_filter(_v, rawExpr='$sensor.node_name.inline_filter')) # from line 601, col 17.
                write('''">''')
                _v = VFFSL(SL,"sensor.node_name.value",True) # '$sensor.node_name.value' on line 601, col 50
                if _v is not None: write(_filter(_v, rawExpr='$sensor.node_name.value')) # from line 601, col 50.
                write('''</a>)
''')
            write('''    <br/>
''')
        write('''</td>
<td>
''')
        if VFFSL(SL,"message.aggregated",True): # generated from line 607, col 3
            if VFFSL(SL,"message.time_min.value",True) == VFFSL(SL,"message.time_max.value",True): # generated from line 608, col 5
                write('''      ''')
                _v = VFFSL(SL,"message.time_min.value",True) # '$message.time_min.value' on line 609, col 7
                if _v is not None: write(_filter(_v, rawExpr='$message.time_min.value')) # from line 609, col 7.
                write('''
''')
            else: # generated from line 610, col 5
                write('''      ''')
                _v = VFFSL(SL,"message.time_max.value",True) # '$message.time_max.value' on line 611, col 7
                if _v is not None: write(_filter(_v, rawExpr='$message.time_max.value')) # from line 611, col 7.
                write(''' -
      ''')
                _v = VFFSL(SL,"message.time_min.value",True) # '$message.time_min.value' on line 612, col 7
                if _v is not None: write(_filter(_v, rawExpr='$message.time_min.value')) # from line 612, col 7.
                write('''
''')
        else: # generated from line 614, col 3
            write('''    ''')
            _v = VFFSL(SL,"message.time.value",True) # '$message.time.value' on line 615, col 5
            if _v is not None: write(_filter(_v, rawExpr='$message.time.value')) # from line 615, col 5.
            write('''
''')
            if VFFSL(SL,"message.analyzer_time.value",True): # generated from line 616, col 5
                write('''      (sent at ''')
                _v = VFFSL(SL,"message.analyzer_time.value",True) # '$message.analyzer_time.value' on line 617, col 16
                if _v is not None: write(_filter(_v, rawExpr='$message.analyzer_time.value')) # from line 617, col 16.
                write(''')
''')
        write('''</td>
''')
        _filter = self._CHEETAH__currentFilter = _orig_filter_40489839
        _orig_filter_54298417 = _filter
        filterName = 'Filter'
        if self._CHEETAH__filters.has_key("Filter"):
            _filter = self._CHEETAH__currentFilter = self._CHEETAH__filters[filterName]
        else:
            _filter = self._CHEETAH__currentFilter = \
			self._CHEETAH__filters[filterName] = getattr(self._CHEETAH__filtersLib, filterName)(self).filter
        _filter = self._CHEETAH__currentFilter = _orig_filter_54298417
        
        ########################################
        ## END - generated method body
        
        return _dummyTrans and trans.response().getvalue() or ""
        

    def orderby_option(self, **KWS):



        ## CHEETAH: generated from #block orderby_option at line 627, col 1.
        trans = KWS.get("trans")
        if (not trans and not self._CHEETAH__isBuffering and not callable(self.transaction)):
            trans = self.transaction # is None unless self.awake() was called
        if not trans:
            trans = DummyTransaction()
            _dummyTrans = True
        else: _dummyTrans = False
        write = trans.response().write
        SL = self._CHEETAH__searchList
        _filter = self._CHEETAH__currentFilter
        
        ########################################
        ## START - generated method body
        
        write('''     <option value="time_desc" ''')
        _v = VFFSL(SL,"timeline.time_desc_selected",True) # '$timeline.time_desc_selected' on line 628, col 32
        if _v is not None: write(_filter(_v, rawExpr='$timeline.time_desc_selected')) # from line 628, col 32.
        write('''>By time (descending)</option>
     <option value="time_asc" ''')
        _v = VFFSL(SL,"timeline.time_asc_selected",True) # '$timeline.time_asc_selected' on line 629, col 31
        if _v is not None: write(_filter(_v, rawExpr='$timeline.time_asc_selected')) # from line 629, col 31.
        write('''>By time (ascending)</option>
     <option value="count_desc" ''')
        _v = VFFSL(SL,"timeline.count_desc_selected",True) # '$timeline.count_desc_selected' on line 630, col 33
        if _v is not None: write(_filter(_v, rawExpr='$timeline.count_desc_selected')) # from line 630, col 33.
        write('''>By count (descending)</option>
     <option value="count_asc" ''')
        _v = VFFSL(SL,"timeline.count_asc_selected",True) # '$timeline.count_asc_selected' on line 631, col 32
        if _v is not None: write(_filter(_v, rawExpr='$timeline.count_asc_selected')) # from line 631, col 32.
        write('''>By count (ascending)</option>
''')
        
        ########################################
        ## END - generated method body
        
        return _dummyTrans and trans.response().getvalue() or ""
        

    def timeline_extra_content(self, **KWS):



        ## CHEETAH: generated from #block timeline_extra_content at line 635, col 1.
        trans = KWS.get("trans")
        if (not trans and not self._CHEETAH__isBuffering and not callable(self.transaction)):
            trans = self.transaction # is None unless self.awake() was called
        if not trans:
            trans = DummyTransaction()
            _dummyTrans = True
        else: _dummyTrans = False
        write = trans.response().write
        SL = self._CHEETAH__searchList
        _filter = self._CHEETAH__currentFilter
        
        ########################################
        ## START - generated method body
        
        _orig_filter_39668083 = _filter
        filterName = 'CleanOutput'
        if self._CHEETAH__filters.has_key("CleanOutput"):
            _filter = self._CHEETAH__currentFilter = self._CHEETAH__filters[filterName]
        else:
            _filter = self._CHEETAH__currentFilter = \
			self._CHEETAH__filters[filterName] = getattr(self._CHEETAH__filtersLib, filterName)(self).filter
        write('''<tr>
  <th id="filter_control_label">''')
        if False:
            _("Filter")
        _v = VFFSL(SL,"_",False)("Filter") # '$_("Filter")' on line 638, col 33
        if _v is not None: write(_filter(_v, rawExpr='$_("Filter")')) # from line 638, col 33.
        write('''</th>
  <td colspan="2">
   <select name="filter" size="1" class="filter_control_select">
    <option value="">&nbsp;</option>
''')
        for fltr in VFFSL(SL,"filters",True): # generated from line 642, col 3
            write('''    <option value="''')
            _v = VFFSL(SL,"fltr",True) # '$fltr' on line 643, col 20
            if _v is not None: write(_filter(_v, rawExpr='$fltr')) # from line 643, col 20.
            write('''" ''')
            if VFFSL(SL,"fltr",True) == VFFSL(SL,"current_filter",True): # generated from line 643, col 27
                write(''' selected="selected" ''')
            write('''>''')
            _v = VFFSL(SL,"fltr",True) # '$fltr' on line 643, col 86
            if _v is not None: write(_filter(_v, rawExpr='$fltr')) # from line 643, col 86.
            write('''</option>
''')
        write('''  </select>
 </td>
</tr>
''')
        _filter = self._CHEETAH__currentFilter = _orig_filter_39668083
        _orig_filter_80099531 = _filter
        filterName = 'Filter'
        if self._CHEETAH__filters.has_key("Filter"):
            _filter = self._CHEETAH__currentFilter = self._CHEETAH__filters[filterName]
        else:
            _filter = self._CHEETAH__currentFilter = \
			self._CHEETAH__filters[filterName] = getattr(self._CHEETAH__filtersLib, filterName)(self).filter
        _filter = self._CHEETAH__currentFilter = _orig_filter_80099531
        
        ########################################
        ## END - generated method body
        
        return _dummyTrans and trans.response().getvalue() or ""
        

    def writeBody(self, **KWS):



        ## CHEETAH: main method generated for this template
        trans = KWS.get("trans")
        if (not trans and not self._CHEETAH__isBuffering and not callable(self.transaction)):
            trans = self.transaction # is None unless self.awake() was called
        if not trans:
            trans = DummyTransaction()
            _dummyTrans = True
        else: _dummyTrans = False
        write = trans.response().write
        SL = self._CHEETAH__searchList
        _filter = self._CHEETAH__currentFilter
        
        ########################################
        ## START - generated method body
        
        write('''
''')
        self.head_extra_content(trans=trans)
        write('''

''')
        self.message_fields_header(trans=trans)
        write('''

''')
        self.message_fields(trans=trans)
        write('''

''')
        self.orderby_option(trans=trans)
        write('''

''')
        self.timeline_extra_content(trans=trans)
        
        ########################################
        ## END - generated method body
        
        return _dummyTrans and trans.response().getvalue() or ""
        
    ##################################################
    ## CHEETAH GENERATED ATTRIBUTES


    _CHEETAH__instanceInitialized = False

    _CHEETAH_version = __CHEETAH_version__

    _CHEETAH_versionTuple = __CHEETAH_versionTuple__

    _CHEETAH_genTime = __CHEETAH_genTime__

    _CHEETAH_genTimestamp = __CHEETAH_genTimestamp__

    _CHEETAH_src = __CHEETAH_src__

    _CHEETAH_srcLastModified = __CHEETAH_srcLastModified__

    _mainCheetahMethod_for_AlertListing= 'writeBody'

## END CLASS DEFINITION

if not hasattr(AlertListing, '_initCheetahAttributes'):
    templateAPIClass = getattr(AlertListing, '_CHEETAH_templateClass', Template)
    templateAPIClass._addCheetahPlumbingCodeToClass(AlertListing)


# CHEETAH was developed by Tavis Rudd and Mike Orr
# with code, advice and input from many other volunteers.
# For more information visit http://www.CheetahTemplate.org/

##################################################
## if run from command line:
if __name__ == '__main__':
    from Cheetah.TemplateCmdLineIface import CmdLineIface
    CmdLineIface(templateObj=AlertListing()).run()


