#!/usr/bin/env python




##################################################
## DEPENDENCIES
import sys
import os
import os.path
from os.path import getmtime, exists
import time
import types
import __builtin__
from Cheetah.Version import MinCompatibleVersion as RequiredCheetahVersion
from Cheetah.Version import MinCompatibleVersionTuple as RequiredCheetahVersionTuple
from Cheetah.Template import Template
from Cheetah.DummyTransaction import DummyTransaction
from Cheetah.NameMapper import NotFound, valueForName, valueFromSearchList, valueFromFrameOrSearchList
from Cheetah.CacheRegion import CacheRegion
import Cheetah.Filters as Filters
import Cheetah.ErrorCatchers as ErrorCatchers
import cgi
from prewikka.templates.ClassicLayout import ClassicLayout

##################################################
## MODULE CONSTANTS
try:
    True, False
except NameError:
    True, False = (1==1), (1==0)
VFFSL=valueFromFrameOrSearchList
VFSL=valueFromSearchList
VFN=valueForName
currentTime=time.time
__CHEETAH_version__ = '2.0.1'
__CHEETAH_versionTuple__ = (2, 0, 1, 'final', 0)
__CHEETAH_genTime__ = 1228925676.459929
__CHEETAH_genTimestamp__ = 'Wed Dec 10 16:14:36 2008'
__CHEETAH_src__ = 'prewikka/templates/ErrorTemplate.tmpl'
__CHEETAH_srcLastModified__ = 'Tue Mar  4 09:31:58 2008'
__CHEETAH_docstring__ = 'Autogenerated by CHEETAH: The Python-Powered Template Engine'

if __CHEETAH_versionTuple__ < RequiredCheetahVersionTuple:
    raise AssertionError(
      'This template was compiled with Cheetah version'
      ' %s. Templates compiled before version %s must be recompiled.'%(
         __CHEETAH_version__, RequiredCheetahVersion))

##################################################
## CLASSES

class ErrorTemplate(ClassicLayout):

    ##################################################
    ## CHEETAH GENERATED METHODS


    def __init__(self, *args, **KWs):

        ClassicLayout.__init__(self, *args, **KWs)
        if not self._CHEETAH__instanceInitialized:
            cheetahKWArgs = {}
            allowedKWs = 'searchList namespaces filter filtersLib errorCatcher'.split()
            for k,v in KWs.items():
                if k in allowedKWs: cheetahKWArgs[k] = v
            self._initCheetahInstance(**cheetahKWArgs)
        

    def main_content(self, **KWS):



        ## CHEETAH: generated from #block main_content at line 4, col 1.
        trans = KWS.get("trans")
        if (not trans and not self._CHEETAH__isBuffering and not callable(self.transaction)):
            trans = self.transaction # is None unless self.awake() was called
        if not trans:
            trans = DummyTransaction()
            _dummyTrans = True
        else: _dummyTrans = False
        write = trans.response().write
        SL = self._CHEETAH__searchList
        _filter = self._CHEETAH__currentFilter
        
        ########################################
        ## START - generated method body
        
        _orig_filter_22516491 = _filter
        filterName = 'CleanOutput'
        if self._CHEETAH__filters.has_key("CleanOutput"):
            _filter = self._CHEETAH__currentFilter = self._CHEETAH__filters[filterName]
        else:
            _filter = self._CHEETAH__currentFilter = \
			self._CHEETAH__filters[filterName] = getattr(self._CHEETAH__filtersLib, filterName)(self).filter
        write('''
<div id="fieldset_page" style="position: absolute; top: 25%; left: 50%; width:600px; margin-left:-220px;">
  <fieldset style="text-align: center; vertical-align: middle;"> 
   <legend class="error_name">''')
        _v = VFFSL(SL,"name",True) # '$name' on line 9, col 31
        if _v is not None: write(_filter(_v, rawExpr='$name')) # from line 9, col 31.
        write('''</legend>
   <p><b>''')
        _v = VFFSL(SL,"message",True) # '$message' on line 10, col 10
        if _v is not None: write(_filter(_v, rawExpr='$message')) # from line 10, col 10.
        write('''</b></p>
''')
        if VFFSL(SL,"traceback",True): # generated from line 11, col 4
            write('''     <br/><br/>
     <textarea rows=10 cols=75 readonly>''')
            _v = VFFSL(SL,"traceback",True) # '$traceback' on line 13, col 41
            if _v is not None: write(_filter(_v, rawExpr='$traceback')) # from line 13, col 41.
            write('''</textarea>
''')
        write('''
   <br/><br/>

''')
        curparam = VFN(VFFSL(SL,"cgi",True),"parse_qs",False)(VFFSL(SL,"prewikka.url.current",True))
        write('''
''')
        if VFN(VFFSL(SL,"curparam",True),"has_key",False)('_error_back'): # generated from line 20, col 1
            referer_string = VFFSL(SL,"curparam",True)['_error_back'][0]
            referer = VFN(VFFSL(SL,"cgi",True),"parse_qs",False)(VFFSL(SL,"referer_string",True))
        else: # generated from line 23, col 1
            referer_string = VFFSL(SL,"prewikka.url.referer",True)
            referer = VFN(VFFSL(SL,"cgi",True),"parse_qs",False)(VFFSL(SL,"referer_string",True))
        write('''
''')
        if VFN(VFFSL(SL,"curparam",True),"has_key",False)('_error_retry'): # generated from line 28, col 1
            retry_string = VFFSL(SL,"curparam",True)['_error_retry'][0]
            retry = VFN(VFFSL(SL,"cgi",True),"parse_qs",False)(VFFSL(SL,"retry_string",True))
        else: # generated from line 31, col 1
            retry_string = VFFSL(SL,"prewikka.url.current",True)
            retry = VFN(VFFSL(SL,"cgi",True),"parse_qs",False)(VFFSL(SL,"prewikka.url.current",True))
        write('''

   <form method="POST" action="?">
''')
        for param, values in VFN(VFFSL(SL,"referer",True),"items",False)(): # generated from line 38, col 6
            for value in VFFSL(SL,"values",True): # generated from line 39, col 8
                write('''         <input type="hidden" name="''')
                _v = VFFSL(SL,"param",True) # '$param' on line 40, col 37
                if _v is not None: write(_filter(_v, rawExpr='$param')) # from line 40, col 37.
                write('''" value="''')
                _v = VFFSL(SL,"value",True) # '$value' on line 40, col 52
                if _v is not None: write(_filter(_v, rawExpr='$value')) # from line 40, col 52.
                write('''"/>
''')
        write('''
''')
        if not VFN(VFFSL(SL,"referer",True),"has_key",False)("_error_back"): # generated from line 44, col 1
            write('''     <input type="hidden" name="_error_back" value="''')
            _v = VFFSL(SL,"referer_string",True) # '$referer_string' on line 45, col 53
            if _v is not None: write(_filter(_v, rawExpr='$referer_string')) # from line 45, col 53.
            write('''" />
''')
        write('''
''')
        if not VFN(VFFSL(SL,"referer",True),"has_key",False)("_error_retry"): # generated from line 48, col 1
            write('''     <input type="hidden" name="_error_retry" value="''')
            _v = VFFSL(SL,"retry_string",True) # '$retry_string' on line 49, col 54
            if _v is not None: write(_filter(_v, rawExpr='$retry_string')) # from line 49, col 54.
            write('''" />
''')
        write('''     <input style="float: left; position: relative;" type="submit" value="Back"/>
   </form>

   <form method="POST" action="?">
''')
        for param, values in VFN(VFFSL(SL,"retry",True),"items",False)(): # generated from line 55, col 6
            for value in VFFSL(SL,"values",True): # generated from line 56, col 8
                write('''         <input type="hidden" name="''')
                _v = VFFSL(SL,"param",True) # '$param' on line 57, col 37
                if _v is not None: write(_filter(_v, rawExpr='$param')) # from line 57, col 37.
                write('''" value="''')
                _v = VFFSL(SL,"value",True) # '$value' on line 57, col 52
                if _v is not None: write(_filter(_v, rawExpr='$value')) # from line 57, col 52.
                write('''"/>
''')
        write('''
''')
        if not VFN(VFFSL(SL,"retry",True),"has_key",False)("_error_back"): # generated from line 61, col 1
            write('''     <input type="hidden" name="_error_back" value="''')
            _v = VFFSL(SL,"referer_string",True) # '$referer_string' on line 62, col 53
            if _v is not None: write(_filter(_v, rawExpr='$referer_string')) # from line 62, col 53.
            write('''" />
''')
        write('''
''')
        if not VFN(VFFSL(SL,"retry",True),"has_key",False)("_error_retry"): # generated from line 65, col 1
            write('''     <input type="hidden" name="_error_retry" value="''')
            _v = VFFSL(SL,"retry_string",True) # '$retry_string' on line 66, col 54
            if _v is not None: write(_filter(_v, rawExpr='$retry_string')) # from line 66, col 54.
            write('''" />
''')
        write('''
     <input style="float: right; position: relative;" type="submit" value="Retry"/>
   </form>

  </fieldset>
 </div>

''')
        _filter = self._CHEETAH__currentFilter = _orig_filter_22516491
        
        ########################################
        ## END - generated method body
        
        return _dummyTrans and trans.response().getvalue() or ""
        

    def writeBody(self, **KWS):



        ## CHEETAH: main method generated for this template
        trans = KWS.get("trans")
        if (not trans and not self._CHEETAH__isBuffering and not callable(self.transaction)):
            trans = self.transaction # is None unless self.awake() was called
        if not trans:
            trans = DummyTransaction()
            _dummyTrans = True
        else: _dummyTrans = False
        write = trans.response().write
        SL = self._CHEETAH__searchList
        _filter = self._CHEETAH__currentFilter
        
        ########################################
        ## START - generated method body
        
        write('''
''')
        self.main_content(trans=trans)
        
        ########################################
        ## END - generated method body
        
        return _dummyTrans and trans.response().getvalue() or ""
        
    ##################################################
    ## CHEETAH GENERATED ATTRIBUTES


    _CHEETAH__instanceInitialized = False

    _CHEETAH_version = __CHEETAH_version__

    _CHEETAH_versionTuple = __CHEETAH_versionTuple__

    _CHEETAH_genTime = __CHEETAH_genTime__

    _CHEETAH_genTimestamp = __CHEETAH_genTimestamp__

    _CHEETAH_src = __CHEETAH_src__

    _CHEETAH_srcLastModified = __CHEETAH_srcLastModified__

    _mainCheetahMethod_for_ErrorTemplate= 'writeBody'

## END CLASS DEFINITION

if not hasattr(ErrorTemplate, '_initCheetahAttributes'):
    templateAPIClass = getattr(ErrorTemplate, '_CHEETAH_templateClass', Template)
    templateAPIClass._addCheetahPlumbingCodeToClass(ErrorTemplate)


# CHEETAH was developed by Tavis Rudd and Mike Orr
# with code, advice and input from many other volunteers.
# For more information visit http://www.CheetahTemplate.org/

##################################################
## if run from command line:
if __name__ == '__main__':
    from Cheetah.TemplateCmdLineIface import CmdLineIface
    CmdLineIface(templateObj=ErrorTemplate()).run()


